import astropy,os,scipy,scipy.interpolate
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
from scipy.optimize import curve_fit

os.system('ls e*.fits > fits.lst')
a=np.linspace(23,2023,81)
b=np.linspace(0,0,81)
x=np.linspace(0,9999,10000)
y=np.linspace(0,0,2048)
sky=np.empty((64,500))
sky_all=np.empty((500))

os.system('rm -f fitting_para.dat'))
output=open("fitting_para.dat","w")

for k in range(16):
    j=0
    for line in open("fits.lst"):
        line=line.strip("\n")
        objectname=fits.getval(line,'OBJECT',0)
        if (objectname != 'flat') and (objectname != 'zero'):
#        print line, objectname
            object=fits.open(line)

            bias=fits.open('bias.fits')
            data_bias=bias[k+1].data
#            flat_sky=fits.open('flat_sky.fits')
#            flat=fits.open('flat.fits')
#            data_flat=flat[k+1].data
#            data_flat_sky=flat_sky[k+1].data

            data=object[k+1].data 
            for i in range(2048):
                xmedian=np.median(data[i,2016:2036])
                y[i]=xmedian

            for i in range(81):
                b[i]=np.median(y[i*25+3:43+i*25])

            c=scipy.interpolate.UnivariateSpline(a,b)
#            c.set_smoothing_factor(1)
#            plt.plot(x,y,'b',lw=1)
#            plt.plot(x,c(x),'y',lw=3)
            c.set_smoothing_factor(5)
#            plt.plot(x,c(x),'r',lw=3)
#            plt.show()
#            raw_input()

            for i in range(2048):
                data[i,:2016]=(data[i,:2016]-c(i)-data_bias[i,:2016])
#                data[i,:2016]=(data[i,:2016]-c(i)-data_bias[i,:2016])/data_flat[i,:2016]

#            plt.plot(x,data[:,1500:1501])

            sky_all[j]=np.median(data)
            for m in range(8):
                for n in range(8):
                    sky[m*8+n,j]=np.median(data[m*256:(m+1)*256,n*252:(n+1)*252])

            for n in range(8):
                if (sky[56+n,j]/sky_all[j] < 1.2):
                    id_s=56+n

            sky1=sky[:,j]/sky[id_s,j]
            sky1.sort(0)

            if (sky1[63] < 1.2):
                j=j+1

            bias.close()
            object.close()

    num=j-1

    def func(x,a,b):
        return a*np.exp(b/x)

    print 'CCD  ',k+1
    output.write('CCD  '+str(k+1)+"\n")
        
    for j in range(64):
        popt, pcov = curve_fit(func,sky[j,0:num],sky[j,0:num]/sky[id_s,0:num])
        aa=popt[0]
        bb=popt[1]
        cc=func(x,aa,bb)
        print aa,bb#,sky[j,106]/sky[id_s,106]
	output.write(str(aa)+"   "+str(bb)+"\n")
#        plt.axis([0.,2000.0,0.85,1.05])
#        plt.plot(sky[j,:],sky[j,:]/sky[id_s,:],'bo')
#        plt.plot(x,cc,'r',lw=3)
#        plt.plot(sky[j,:],sky[j,:]/sky[id_s,:],'o')
#        plt.xlabel('Sky ADU') 
#        plt.ylabel('Sky ADU / Sky ADU (standard)')
#        plt.show()
#        raw_input()
output.close()
